/*
 *    setstrut (c) Alexander Polakov <polachok@gmail.com>
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <locale.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>

Display *dpy;
Window root;
int screen;
Atom ewmhstrut;
Window win;

int 
main(int argc, char *argv[]) {
    dpy = XOpenDisplay(0);
    screen = DefaultScreen(dpy);
    root = RootWindow(dpy, screen);
    int struts[12];
    int i;

    ewmhstrut = XInternAtom(dpy, "_NET_WM_STRUT_PARTIAL", False);

    if(argc < 5){
        fprintf(stderr, "usage: setstrut <windowid> <left> <right> <top> <bottom> <left_start_y> <left_end_y> \
                <right_start_y> <right_end_y> <top_start_x> <top_end_x> <bottom_start_x> \
                <bottom_end_x>\n");
        return 1;
    }

    sscanf(argv[1], "0x%lx", &win);
    printf("Window: 0x%lx argv[1]=%s\n", win, argv[1]);

    for(i = 0; i < 12; i++)
        struts[i] = i+2 < argc ? atoi(argv[i+2]) : 0;
    XChangeProperty(dpy, win, ewmhstrut, XA_CARDINAL, 32, PropModeReplace, (unsigned char*)struts, 12);
    XSync(dpy, False);
}
